﻿TidyPlatesThreat = LibStub("AceAddon-3.0"):NewAddon("TidyPlatesThreat", "AceConsole-3.0","AceEvent-3.0")
local Media = LibStub("LibSharedMedia-3.0")
local DataBroker = LibStub:GetLibrary("LibDataBroker-1.1",true)
local path = "Interface\\Addons\\TidyPlates_ThreatPlates\\Artwork\\"
local classicon = "Interface\\Addons\\TidyPlates_ThreatPlates\\Artwork\\class\\"
local _, PlayerClass = UnitClass("player")
local classColors = { 
SHAMAN 		= "2459FF", 
MAGE 		= "69CCF0",
WARLOCK 	= "9482C9",
HUNTER		= "ABD473",
ROGUE		= "FFF569",
PRIEST		= "FFFFFF",
DRUID 		= "FF7D0A",
DEATHKNIGHT = "C41F3B",
WARRIOR 	= "C79C6E",
PALADIN 	= "F58CBA",
}


--[[Set MultiStyle]]--
if not TidyPlatesThemeList then TidyPlatesThemeList = {} end
TidyPlatesThemeList["Threat Plates"] = {}

-- Dual Spec Functions
local currentSpec = {}

function currentRoleBool(number)
	currentSpec[1] = TidyPlatesThreat.db.profile.spec.primary
	currentSpec[2] = TidyPlatesThreat.db.profile.spec.secondary
	if currentSpec[number] then return currentSpec[number] end
end

function dualSpec(current) --Staggered till after called
	currentSpec[3] = ""
	if GetActiveTalentGroup() == 1 then
		currentSpec[3] = "primary"
	elseif GetActiveTalentGroup() == 2 then
		currentSpec[3] = "secondary"
	else 
		currentSpec[3] = "unknown"
	end
	return currentSpec[3]
end

function roleText(current) --Staggered till after called
	if GetActiveTalentGroup() == 1 then
		if TidyPlatesThreat.db.profile.spec.primary then
			return "|cff00ff00tanking|r"
		else
			return "|cffff0000dpsing / healing|r"
		end
	elseif GetActiveTalentGroup() == 2 then
		if TidyPlatesThreat.db.profile.spec.secondary then
			return "|cff00ff00tanking|r"
		else
			return "|cffff0000dpsing / healing|r"
		end
	end
end

-- Nameplate Toggle Functions

local function GetToggleNameplate(info)
	return TidyPlatesThreat.db.profile.nameplate.toggle[info.arg]
end

local function SetToggleNameplate(info)
	TidyPlatesThreat.db.profile.nameplate.toggle[info.arg] = not TidyPlatesThreat.db.profile.nameplate.toggle[info.arg]
	if TidyPlatesThreat.db.profile.nameplate.toggle[info.arg] then return print("-->>"..info.arg.." nameplates are now |cff00ff00ON!|r<<--") else return print("-->>"..info.arg.." nameplates are now |cffff0000OFF!|r<<--") end
	TidyPlates:ForceUpdate()
end

local function GetNameplateScale(info)
	return TidyPlatesThreat.db.profile.nameplate.scale[info.arg]
end

local function SetNameplateScale(info, v)
	TidyPlatesThreat.db.profile.nameplate.scale[info.arg] = v
	TidyPlates:ForceUpdate()
end

local function GetNameplateAlpha(info)
	return TidyPlatesThreat.db.profile.nameplate.alpha[info.arg]
end

local function SetNameplateAlpha(info, v)
	TidyPlatesThreat.db.profile.nameplate.alpha[info.arg] = v
	TidyPlates:ForceUpdate()
end

-- Nameplate Auto Hide

local function CombatAutoHide()
	if TidyPlatesThreat.db.profile.nameplate.autohide then
		--TidyPlates:UseAutoHide(true)
		TidyPlatesThreat.db.profile.nameplate.autohide = false
		print("-->>Auto hiding of nameplates upon leaving combat is now |cffff0000OFF!|r<<--")
	elseif not TidyPlatesThreat.db.profile.nameplate.autohide then
		--TidyPlates:UseAutoHide(false)
		TidyPlatesThreat.db.profile.nameplate.autohide = true
		print("-->>Auto hiding of nameplates upon leaving combat is now |cff00ff00ON!|r<<--")
	end
	TidyPlates:ForceUpdate()
end

-- Threat Toggle Functions
local function GetThreatToggle(info)
	return TidyPlatesThreat.db.profile.threat.toggle[info.arg]
end

local function SetThreatToggle(info)
	TidyPlatesThreat.db.profile.threat.toggle[info.arg] = not TidyPlatesThreat.db.profile.threat.toggle[info.arg]
	if TidyPlatesThreat.db.profile.threat.toggle[info.arg] then return print("-->>|cff00ff00"..info.arg.." Threat System is now ON!|r<<--") else return print("-->>|cffff0000"..info.arg.." Threat System is now OFF!|r<<--") end
	TidyPlates:ForceUpdate()
end

local function GetThreatScaleDPS(info)	
	return TidyPlatesThreat.db.profile.threat.dps.scale[info.arg]
end

local function SetThreatScaleDPS(info, v)	
	TidyPlatesThreat.db.profile.threat.dps.scale[info.arg] = v
	TidyPlates:ForceUpdate()
end

local function GetThreatScaleTANK(info)	
	return TidyPlatesThreat.db.profile.threat.tank.scale[info.arg]
end

local function SetThreatScaleTANK(info, v)	
	TidyPlatesThreat.db.profile.threat.tank.scale[info.arg] = v
	TidyPlates:ForceUpdate()
end

local function GetThreatAlphaDPS(info)	
	return TidyPlatesThreat.db.profile.threat.dps.alpha[info.arg]
end

local function SetThreatAlphaDPS(info, v)	
	TidyPlatesThreat.db.profile.threat.dps.alpha[info.arg] = v
	TidyPlates:ForceUpdate()
end

local function GetThreatAlphaTANK(info)	
	return TidyPlatesThreat.db.profile.threat.tank.alpha[info.arg]
end

local function SetThreatAlphaTANK(info, v)	
	TidyPlatesThreat.db.profile.threat.tank.alpha[info.arg] = v
	TidyPlates:ForceUpdate()
end

-- Unit Classification
local function UnitType(unit)
	local unitRank
	if (unit.isDangerous and (unit.reaction == "FRIENDLY" or unit.reaction == "HOSTILE")) then
		unitRank = "Boss"
	elseif (unit.isElite and not unit.isDangerous and (unit.reaction == "FRIENDLY" or unit.reaction == "HOSTILE")) then
		unitRank = "Elite"
	elseif (not unit.isElite and not unit.isDangerous and (unit.reaction == "FRIENDLY" or unit.reaction == "HOSTILE"))then
		unitRank = "Normal"
	elseif unit.reaction == "NEUTRAL" then
		unitRank = "Neutral"
	end
	return unitRank
end

--[[Options and Default Settings]]--
function TidyPlatesThreat:OnInitialize()
	local options = { 
		type = "group", 
		args = {
			OptionsDescription = {
				type = "description",
				order = 1,
				name = "Clear and easy to use nameplate theme for use with TidyPlates.\nFeel free to email me at |cff00ff00Shamtasticle@gmail.com|r\n|cff2459FFSyronius|r, of Black Dragonflight - US <Fallout>",
			},
--[[Options Frames]]--
			OptionsHeader = {
				order = 2,
				type = "header",
				name = GetAddOnMetadata("TidyPlates_ThreatPlates", "title").." v"..GetAddOnMetadata("TidyPlates_ThreatPlates", "version"),
			},
			NameplateOptFrame = {
		        order = 3,
		        type  = "group",
       			name  = "Nameplate Options",
		        args = {
					description = {
						type = "description",
						order = 1,
						name = "Toggle the showing and hiding of nameplates.",
					},
					ShowNeutral = {
						type = "toggle",
						order = 2,
						name = "Show Neutral",
						get = GetToggleNameplate,
						set = SetToggleNameplate,
						arg = "Neutral",
					},
					ShowNormal = {
						type = "toggle",
						order = 3,
						name = "Show Normal",
						get = GetToggleNameplate,
						set = SetToggleNameplate,
						arg = "Normal",
					},
					ShowElite = {
						type = "toggle",
						order = 4,
						name = "Show Elite",
						get = GetToggleNameplate,
						set = SetToggleNameplate,
						arg = "Elite",
					},
					ShowBoss = {
						type = "toggle",
						order = 5,
						name = "Show Boss",
						get = GetToggleNameplate,
						set = SetToggleNameplate,
						arg = "Boss",
					},
					--[[
					Header = {
						type = 'header',
						order = 6,
						name = "Auto Hide Nameplates",
					},
					Description = {
						type = 'description',
						order = 7,
						name = "Toggle the auto hiding of nameplates after leaving combat."
					},
					UseAutoHide = {
						type = "toggle",
						order = 8,
						name = "Enable Autohide",
						get = function() return self.db.profile.nameplate.autohide end,
						set = CombatAutoHide,
					},
					]]--
					Scale = {
						type = "group",
						order = 6,
						name = "Nameplate Scale",
						desc = "Set nameplate scale levels",
						args = {
							levels = {
								type = "header",
								order = 3,
								name = "Nameplate Scale Levels",
							},
							Neutral_scale = {
								type 	= "range",
								order 	= 4,
								name 	= "Neutral Scale",
								arg 	= "Neutral",
								get 	= GetNameplateScale,
								set		= SetNameplateScale,
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							Normal_scale = {
								type 	= "range",
								order 	= 5,
								name 	= "Normal Scale",
								arg 	= "Normal",
								get 	= GetNameplateScale,
								set		= SetNameplateScale,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							Elite_scale = {
								type 	= "range",
								order 	= 6,
								name 	= "Elite Scale",
								arg 	= "Elite",
								get 	= GetNameplateScale,
								set		= SetNameplateScale,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							Boss_scale = {
								type 	= "range",
								order 	= 7,
								name 	= "Boss Scale",
								arg 	= "Boss",
								get 	= GetNameplateScale,
								set		= SetNameplateScale,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
						},
					},
					Alpha = {
						type = "group",
						order = 7,
						name = "Nameplate Alpha",
						desc = "Set nameplate alpha levels",
						args = {
							levels = {
								type = "header",
								order = 3,
								name = "Nameplate Alpha Levels",
							},
							Neutral_alpha = {
								type 	= "range",
								order 	= 4,
								name 	= "Neutral alpha",
								arg 	= "Neutral",
								get 	= GetNameplateAlpha,
								set		= SetNameplateAlpha,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							Normal_alpha = {
								type 	= "range",
								order 	= 5,
								name 	= "Normal alpha",
								arg 	= "Normal",
								get 	= GetNameplateAlpha,
								set		= SetNameplateAlpha,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							Elite_alpha = {
								type 	= "range",
								order 	= 6,
								name 	= "Elite alpha",
								arg 	= "Elite",
								get 	= GetNameplateAlpha,
								set		= SetNameplateAlpha,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							Boss_alpha = {
								type 	= "range",
								order 	= 7,
								name 	= "Boss alpha",
								arg 	= "Boss",
								get 	= GetNameplateAlpha,
								set		= SetNameplateAlpha,							
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
						},
					},
				},
			},
			TextOptFrame = {
		        order = 4,
		        type  = "group",
       			name  = "Text Options",
		        args = {
					TextOptHeader = {
						order = 1,
						type = "header",
						name = "Text Options",
					},
					hptextdesc = {
						order = 2,
						type = "description",
						name = "\nHP Special Text is the center text displaying the truncated HP amount and HP percentage on nameplates.\n",
					},
					hptext = {
						order = 3,
						type = "toggle",
						name = "Show HP Special Text",
						desc = "Toggles the showing and hiding of HP Special Text",
						get = function() return self.db.profile.text.hptext end,
						set = function(info,val) 
							self.db.profile.text.hptext = not self.db.profile.text.hptext
							if self.db.profile.text.hptext then return print("-->>HP Special Text is now |cff00ff00ON!|r<<--") else return print("-->>HP Special Text is now |cffff0000OFF!|r<<--") end
							TidyPlates:ForceUpdate()
						end
					},
					casttext = {
						order = 5,
						type = "toggle",
						name = "Show Spell Cast Text",
						desc = "Toggles the showing and hiding of Spell Cast Text",
						get = function() return self.db.profile.text.cast end,
						set = function(info,val) 
							self.db.profile.text.cast = not self.db.profile.text.cast
							if self.db.profile.text.cast then return print("-->>Spell Cast Text is now |cff00ff00ON!|r<<--") else return print("-->>Spell Cast Text is now |cffff0000OFF!|r<<--") end
							TidyPlates:ForceUpdate()
						end
					},
					formatheader = {
						order = 6,
						type = "header",
						name = "Text Formatting"
					},
					fullhp = {
						order = 7,
						type = "toggle",
						name = "Show HP at full",
						desc = "Display HP when a unit is at 100%.",
						get = function() return self.db.profile.text.full end,
						set = function(info,val)
							self.db.profile.text.full = not self.db.profile.text.full
							if self.db.profile.text.full then return print("-->>Full HP Text is now |cff00ff00ON!|r<<--") else return print("-->>Full HP Text is now |cffff0000OFF!|r<<--") end
							TidyPlates:ForceUpdate()
						end
					},
					hpamount = {
						order = 8,
						type = "toggle",
						name = "Show HP Amount",
						desc = "Display HP amount number text.",
						get = function() return self.db.profile.text.amount end,
						set = function(info,val)
							self.db.profile.text.amount = not self.db.profile.text.amount
							if self.db.profile.text.amount then return print("-->>HP Text Amount is now |cff00ff00ON!|r<<--") else return print("-->>HP Text Amount is now |cffff0000OFF!|r<<--") end
							TidyPlates:ForceUpdate()
						end
					},
					hptruncate = {
						order = 9,
						type = "toggle",
						name = "Truncate HP Amount",
						desc = "Truncate HP amount number text to simplified millions and thousands.",
						get = function() return self.db.profile.text.truncate end,
						set = function(info,val)
							self.db.profile.text.truncate = not self.db.profile.text.truncate
							if self.db.profile.text.truncate then return print("-->>HP Text Amount truncation is now |cff00ff00ON!|r<<--") else return print("-->>HP Text Amount truncation is now |cffff0000OFF!|r<<--") end
							TidyPlates:ForceUpdate()
						end
					},
					hpdeficit = {
						order = 10,
						type = "toggle",
						name = "Deficit HP Amount",
						desc = "Deficit HP amount to show a negative value of HP.",
						get = function() return self.db.profile.text.deficit end,
						set = function(info,val)
							self.db.profile.text.deficit = not self.db.profile.text.deficit
							if self.db.profile.text.deficit then return print("-->>Deficit HP Text Amount is now |cff00ff00ON!|r<<--") else return print("-->>Deficit HP Text Amount is now |cffff0000OFF!|r<<--") end
							TidyPlates:ForceUpdate()
						end
					},
					extrasheader = {
						order = 11,
						type = "header",
						name = "Text Extras"
					},
					hp_percent = {
						order = 12,
						type = "toggle",
						name = "Show HP Percent",
						desc = "Display HP Percent text.",
						get = function() return self.db.profile.text.percent end,
						set = function(info,val)
							self.db.profile.text.percent = not self.db.profile.text.percent
							if self.db.profile.text.percent then return print("-->>HP Percentage Text is now |cff00ff00ON!|r<<--") else return print("-->>HP Percentage Text is now |cffff0000OFF!|r<<--") end
							TidyPlates:ForceUpdate()
						end
					},
					hpmax = {
						order = 13,
						type = "toggle",
						name = "Show HP Maximum",
						desc = "Display HP Max Value text.",
						get = function() return self.db.profile.text.max end,
						set = function(info,val)
							self.db.profile.text.max = not self.db.profile.text.max
							if self.db.profile.text.max then return print("-->>HP Maximum Text is now |cff00ff00ON!|r<<--") else return print("-->>HP Maximum Text is now |cffff0000OFF!|r<<--") end
							TidyPlates:ForceUpdate()
						end
					},
				},
			},
			ThreatOptFrame = {
		        order = 5,
		        type  = "group",
       			name  = "Threat Options",
		        args = {
					ThreatDescription = {
						type = "description",
						order = 1,
						name = "Toggle the threat system on or off",
					},
					threat = {
						order = 2,
						type = "toggle",
						name = "Enable Threat System",
						desc = "Enable or disable the threat plates system.",
						get = function() return self.db.profile.threat.ON end,
						set = function(info,val) 
							self.db.profile.threat.ON = not self.db.profile.threat.ON
							if self.db.profile.threat.ON then return print("-->>|cff00ff00Threat System is now ON!|r<<--") else return print("-->>|cffff0000Threat System is now OFF!|r<<--") end
							TidyPlates:ForceUpdate()
						end
					},
					textures = {
						type = 'select',
						order = 4,
						name = 'Texture',
						desc = 'Set the Threat Art Textures',
						style = dropdown,
						values = ThemeList,
						get = function() return self.db.profile.theme end,
						set = function(info,val)  
							self.db.profile.theme = val
							TidyPlates:ForceUpdate()
							end,
					},
					RoleDescription = {
						type = "description",
						order = 4,
						name = "Select which role you're currently fulfilling.",
					},
					DPSRole = {
						order = 6,
						type = "toggle",
						name = "DPS Role",
						desc = "Enable or disable the threat plates system for DPSing.",
						get = function() return not self.db.profile.threat.tanking end,
						set = function(info,val)
								print("-->>|cff00ff00DPS Role threat system is now active!!|r<<--")
								if GetActiveTalentGroup() == 1 then
									self.db.profile.spec.primary = not self.db.profile.spec.primary
									print("Your |cff89F559primary|r spec has been set to "..roleText(current)..".")
								elseif GetActiveTalentGroup() == 2 then	
									self.db.profile.spec.secondary = not self.db.profile.spec.secondary
									print("Your |cff89F559secondary|r spec has been set to "..roleText(current)..".")
								end
								self.db.profile.threat.tanking = false
								self.db.profile.threat.ON = true
								TidyPlates:ForceUpdate()
							end
					},
					TankRole = {
						order = 5,
						type = "toggle",
						name = "Tank Role",
						desc = "Enable or disable the threat plates system for Tanking.",
						get = function() return self.db.profile.threat.tanking end,
						set = function(info,val) 
								print("-->>|cff00ff00Tank Role threat system is now active!!|r<<--")
								if GetActiveTalentGroup() == 1 then
									self.db.profile.spec.primary = not self.db.profile.spec.primary
									print("Your |cff89F559primary|r spec has been set to "..roleText(current)..".")
								elseif GetActiveTalentGroup() == 2 then	
									self.db.profile.spec.secondary = not self.db.profile.spec.secondary
									print("Your |cff89F559secondary|r spec has been set to "..roleText(current)..".")
								end
								self.db.profile.threat.tanking = true
								self.db.profile.threat.ON = true
								TidyPlates:ForceUpdate()
							end
					},
					AdditionalToggles = {
						order = 7,
						type = "header",
						name = "Additional Toggles",
					},
					Boss_Threat = {
						order = 11,
						type = "toggle",
						name = "Show Boss Threat",
						desc = "Enable or disable the threat plates system for Boss units.",
						arg = "Boss",
						get = GetThreatToggle,
						set = SetThreatToggle,
					},
					Elite_Threat = {
						order = 10,
						type = "toggle",
						name = "Show Elite Threat",
						desc = "Enable or disable the threat plates system for Elite units.",
						arg = "Elite",
						get = GetThreatToggle,
						set = SetThreatToggle,
					},
					Normal_Threat = {
						order = 9,
						type = "toggle",
						name = "Show Normal Threat",
						desc = "Enable or disable the threat plates system for Normal units.",
						arg = "Normal",
						get = GetThreatToggle,
						set = SetThreatToggle,
					},
					Neutral_Threat = {
						order = 8,
						type = "toggle",
						name = "Show Neutral Threat",
						desc = "Enable or disable the threat plates system for Neutral units.",
						arg = "Neutral",
						get = GetThreatToggle,
						set = SetThreatToggle,
					},
					DPS = {
						name = "|cffffffffDPS Threat Levels|r",
						type = "group",
						desc = "Set threat scales and alpha for DPSing",
						order = 1,
						args = {
							scaleheader = {
								type = "header",
								order = 1,
								name = "Nameplate Scale",
							},
							lowthreat = {
								type 	= "range",
								order 	= 2,
								name 	= "|cff00ff00Low Threat Scale|r",
								arg = "LOW",
								get = GetThreatScaleDPS,
								set = SetThreatScaleDPS,
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							medthreat = {
								type 	= "range",
								order 	= 3,
								name 	= "|cffffff00Medium Threat Scale|r",
								arg = "MEDIUM",
								get = GetThreatScaleDPS,
								set = SetThreatScaleDPS,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							highthreat = {
								type 	= "range",
								order 	= 4,
								name 	= "|cffff0000High Threat Scale|r",
								arg = "HIGH",
								get = GetThreatScaleDPS,
								set = SetThreatScaleDPS,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							alphaheader = {
								type = "header",
								order = 5,
								name = "Nameplate Alpha",
							},
							alphalow = {
								type 	= "range",
								order 	= 7,
								name 	= "|cff00ff00Low Threat Alpha|r",
								arg = "LOW",
								get = GetThreatAlphaDPS,
								set = SetThreatAlphaDPS,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							alphaMed = {
								type 	= "range",
								order 	= 8,
								name 	= "|cffffff00Medium Threat Alpha|r",
								arg = "MEDIUM",
								get = GetThreatAlphaDPS,
								set = SetThreatAlphaDPS,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							alphahigh = {
								type 	= "range",
								order 	= 9,
								name 	= "|cffff0000High Threat Alpha|r",
								arg = "HIGH",
								get = GetThreatAlphaDPS,
								set = SetThreatAlphaDPS,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
						},
					},
					Tank = {
						name = "|cffffffffTank Threat Levels|r",
						type = "group",
						desc = "Set threat scales and alpha for Tanking",
						order = 2,
						args = {
							tankdesc = {
								type = "header",
								order = 1,
								name = "Nameplate Scale",
							},
							lowthreat = {
								type 	= "range",
								order 	= 2,
								name 	= "|cffff0000Low Threat Scale|r",
								arg = "LOW",
								get = GetThreatScaleTANK,
								set = SetThreatScaleTANK,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							medthreat = {
								type 	= "range",
								order 	= 3,
								name 	= "|cffffff00Medium Threat Scale|r",
								arg = "MEDIUM",
								get = GetThreatScaleTANK,
								set = SetThreatScaleTANK,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							highthreat = {
								type 	= "range",
								order 	= 4,
								name 	= "|cff00ff00High Threat Scale|r",
								arg = "HIGH",
								get = GetThreatScaleTANK,
								set = SetThreatScaleTANK,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							alphaheader = {
								type = "header",
								order = 5,
								name = "Nameplate Alpha",
							},
							alphalow = {
								type 	= "range",
								order 	= 7,
								name 	= "|cffff0000Low Threat Alpha|r",
								arg = "LOW",
								get = GetThreatAlphaTANK,
								set = SetThreatAlphaTANK,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							alphaMed = {
								type 	= "range",
								order 	= 8,
								name 	= "|cffffff00Medium Threat Alpha|r",
								arg = "MEDIUM",
								get = GetThreatAlphaTANK,
								set = SetThreatAlphaTANK,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							alphahigh = {
								type 	= "range",
								order 	= 9,
								name 	= "|cff00ff00High Threat Alpha|r",
								arg = "HIGH",
								get = GetThreatAlphaTANK,
								set = SetThreatAlphaTANK,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
						},
					},
					Marked = {
						name = "|cffffffffMarked Units|r",
						type = "group",
						desc = "Set threat textures, scales, and alpha for marked units.",
						order = 3,
						args = {
							header1 = {
								order = 1,
								type = "header",
								name = "Marked Mob Ignore Settings"
							},
							descript1 = {
								order = 2,
								type = "description",
								name = "Threat textures, scaling, and alpha changes can be ignored for units that are marked."
							},
							art = {
								order = 3,
								name = "Remove Threat Textures",
								type = "toggle",
								desc = "Disables all threat textures for marked units.",
								get = function() return self.db.profile.threat.marked.art end,
								set = function(info,val) 
									self.db.profile.threat.marked.art = not self.db.profile.threat.marked.art
									if self.db.profile.threat.marked.art then return print("-->>Ignoring of marked unit threat textures is now |cff00ff00ON!|r<<--") else return print("-->>Ignoring of marked unit threat textures is now |cffff0000OFF!|r<<--") end
									TidyPlates:ForceUpdate()
								end
							},
							alpha = {
								order = 4,
								name = "Remove Threat Alpha",
								type = "toggle",
								desc = "Disables all threat alpha settings for marked units.",
								get = function() return self.db.profile.threat.marked.alpha end,
								set = function(info,val) 
									self.db.profile.threat.marked.alpha = not self.db.profile.threat.marked.alpha
									if self.db.profile.threat.marked.alpha then return print("-->>Ignoring of marked unit threat alpha is now |cff00ff00ON!|r<<--") else return print("-->>Ignoring of marked unit threat alpha is now |cffff0000OFF!|r<<--") end
									TidyPlates:ForceUpdate()
								end
							},
							scale = {
								order = 4,
								name = "Remove Threat Scale",
								type = "toggle",
								desc = "Disables all threat scale settings for marked units.",
								get = function() return self.db.profile.threat.marked.scale end,
								set = function(info,val) 
									self.db.profile.threat.marked.scale = not self.db.profile.threat.marked.scale
									if self.db.profile.threat.marked.scale then return print("-->>Ignoring of marked unit threat scale is now |cff00ff00ON!|r<<--") else return print("-->>Ignoring of marked unit threat scale is now |cffff0000OFF!|r<<--") end
									TidyPlates:ForceUpdate()
								end
							},
						},
					},
					SpecSetting = {
						name = "|cffffffffDual Spec Settings|r",
						type = "group",
						desc = "Set the role your primary and secondary spec represent.",
						order = 4,
						args = {
							header = {
								order = 1,
								name = "Dual Spec Settings",
								type = "header"
							},
							description = {
								order = 2,
								name = "Select your role for your primary and secondary specs.",
								type = "description"
							},
							primary = {
								order = 3,
								name = "Primary Spec",
								type = "header"
							},
							primaryTank = {
								order = 4,
								name = "Tank",
								type = "toggle",
								desc = "Sets your primary spec to tanking.",
								get = function() return self.db.profile.spec.primary end,
								set = function(info,val) 
									self.db.profile.spec.primary = true
									if GetActiveTalentGroup() == 1 then
										self.db.profile.threat.tanking = true
									end
									TidyPlates:ForceUpdate()
								end
							},
							primaryDPS = {
								order = 5,
								name = "DPS",
								type = "toggle",
								desc = "Sets your primary spec to DPS.",
								get = function() return not self.db.profile.spec.primary end,
								set = function(info,val) 
									self.db.profile.spec.primary = false
									if GetActiveTalentGroup() == 1 then
										self.db.profile.threat.tanking = false
									end
									TidyPlates:ForceUpdate()
								end
							},
							secondary = {
								order = 6,
								name = "Secondary Spec",
								type = "header"
							},
							secondaryTank = {
								order = 7,
								name = "Tank",
								type = "toggle",
								desc = "Sets your secondary spec to tanking.",
								get = function() return self.db.profile.spec.secondary end,
								set = function(info,val) 
									self.db.profile.spec.secondary = true
									if GetActiveTalentGroup() == 2 then
										self.db.profile.threat.tanking = true
									end
									TidyPlates:ForceUpdate()
								end
							},
							secondaryDPS = {
								order = 8,
								name = "DPS",
								type = "toggle",
								desc = "Sets your secondary spec to DPS.",
								get = function() return not self.db.profile.spec.secondary end,
								set = function(info,val) 
									self.db.profile.spec.secondary = false
									if GetActiveTalentGroup() == 2 then
										self.db.profile.threat.tanking = false
									end
									TidyPlates:ForceUpdate()
								end
							},
						},
					},
				},
			},
		},
	}
	local defaults 	= {
		profile = {
			welcome = false,
			theme = "default",
			text = {
				amount = true,
				cast = true,
				deficit = false,
				full = false,
				hptext = true,
				max = false,
				percent = true,
				truncate = true		
			},
			spec = {
				primary = true,
				secondary = false
			},
			threat = {
				ON = true,
				marked = false,
				tanking = true,
				toggle = {
					["Boss"]	= true,
					["Elite"]	= true,
					["Normal"]	= true,
					["Neutral"]	= true
				},
				dps = {
					scale = {
						LOW 		= 0.8,
						MEDIUM		= 0.9,
						HIGH 		= 1.25
					},
					alpha = {
						LOW 		= 1,
						MEDIUM		= 1,
						HIGH 		= 1
					},
				},
				tank = {
					scale = {
						LOW 		= 1.25,
						MEDIUM		= 0.9,
						HIGH 		= 0.8
					},
					alpha = {
						LOW 		= 1,
						MEDIUM		= 0.85,
						HIGH 		= 0.75
					},
				},
				marked = {
					alpha = false,
					art = false,
					scale = false					
				},
			},
			
			nameplate = {
				autohide = false,
				toggle = {
					["Boss"]	= true,
					["Elite"]	= true,
					["Normal"]	= true,
					["Neutral"]	= true
				},
				scale = {
					["Boss"]	= 1,
					["Elite"]	= 1,
					["Normal"]	= 0.9,
					["Neutral"]	= 0.8
				},
				alpha = {
					["Boss"]	= 1,
					["Elite"]	= 1,
					["Normal"]	= 0.9,
					["Neutral"]	= 0.8
				},
			},
		}
    }
	self.db = LibStub("AceDB-3.0"):New("ThreatPlatesDB", defaults)
	local profile = LibStub('AceDBOptions-3.0'):GetOptionsTable(self.db)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Threat Plates Options", options)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Threat Plates Profiles",  profile)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Threat Plates Options", "Threat Plates Options")
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Threat Plates Profiles", 'Profiles', "Threat Plates Options")
	self:RegisterChatCommand("tptp", function () InterfaceOptionsFrame_OpenToCategory(self.optionsFrame) end)
	
end
--[[TPTP Tank Toggle Command]]--


function toggleDPS()
	if dualSpec(current) == "primary" then
		TidyPlatesThreat.db.profile.spec.primary = false
	elseif dualSpec(current) == "secondary" then
		TidyPlatesThreat.db.profile.spec.secondary = false
	else
		print("spec undetected?")
	end
	TidyPlatesThreat.db.profile.threat.tanking = false
	TidyPlatesThreat.db.profile.threat.ON = true
	print("-->>|cffff0000DPS Plates Enabled|r<<--")
	print("|cff89F559Threat Plates|r: DPS switch detected, you are now in your |cff89F559"..dualSpec(current).."|r spec and are now in your |cffff0000dpsing / healing|r role.")
	TidyPlates:ForceUpdate()
end

function toggleTANK()
	if dualSpec(current) == "primary" then
		TidyPlatesThreat.db.profile.spec.primary = true
	elseif dualSpec(current) == "secondary" then
		TidyPlatesThreat.db.profile.spec.secondary = true
	else
		print("spec undetected?")
	end
	TidyPlatesThreat.db.profile.threat.tanking = true
	TidyPlatesThreat.db.profile.threat.ON = true
	print("-->>|cff00ff00Tank Plates Enabled|r<<--")
	print("|cff89F559Threat Plates|r: Tank switch detected, you are now in your |cff89F559"..dualSpec(current).."|r spec and are now in your |cff00ff00tanking|r role.")
	TidyPlates:ForceUpdate()
end

local function TPTPDPS()
	toggleDPS()
end
SLASH_TPTPDPS1 = "/tptpdps"
SlashCmdList["TPTPDPS"] = TPTPDPS

local function TPTPTANK()
	toggleTANK()
end
SLASH_TPTPTANK1 = "/tptptank"
SlashCmdList["TPTPTANK"] = TPTPTANK


local function TPTPTOGGLE()
	TidyPlatesThreat.db.profile.threat.tanking = not TidyPlatesThreat.db.profile.threat.tanking
	if TidyPlatesThreat.db.profile.threat.tanking then 
		toggleTANK()
	else
		toggleDPS()
	end
end
SLASH_TPTPTOGGLE1 = "/tptptoggle"
SlashCmdList["TPTPTOGGLE"] = TPTPTOGGLE

local function SetStyle(unit)
	local UnitClass = UnitType(unit)
	if unit.reaction == "HOSTILE" or unit.reaction == "NEUTRAL" then
		if TidyPlatesThreat.db.profile.nameplate.toggle[UnitClass] then
			if TidyPlatesThreat.db.profile.threat.toggle[UnitClass] and TidyPlatesThreat.db.profile.threat.ON and unit.class == "UNKNOWN" and InCombatLockdown() then
				if TidyPlatesThreat.db.profile.threat.tanking then
					return "tank"
				else
					return "dps"
				end
			else 
				return "normal"
			end
		else
			return "empty"
		end
	elseif unit.reaction == "FRIENDLY" then
		if TidyPlatesThreat.db.profile.nameplate.toggle[UnitClass] then
			return "normal"
		else
			return "empty"
		end
	else 
		return "empty"
	end
end

local Truncate = function(value)
	if TidyPlatesThreat.db.profile.text.truncate then
		if value >= 1e6 then
			return format('%.1fm', value / 1e6)
		elseif value >= 1e4 then
			return format('%.1fk', value / 1e3)
		else
			return value
		end
	else 
		return value
	end
end

function SetSpecialText(unit)
	local HpPct
	local HpAmt
	local HpMax
	if TidyPlatesThreat.db.profile.text.percent then
		if (TidyPlatesThreat.db.profile.text.amount or TidyPlatesThreat.db.profile.text.max) then
			if TidyPlatesThreat.db.profile.text.deficit and not TidyPlatesThreat.db.profile.text.max and unit.health == unit.healthmax then
				HpPct = floor(100*(unit.health / unit.healthmax)).."%"
			else
				HpPct = " - "..floor(100*(unit.health / unit.healthmax)).."%"
			end
		else
			HpPct = floor(100*(unit.health / unit.healthmax)).."%"
		end
	else
		HpPct = ""
	end
	if TidyPlatesThreat.db.profile.text.amount then
		if TidyPlatesThreat.db.profile.text.deficit then
			if (unit.health == unit.healthmax) then
				HpAmt = ""
			else
				HpAmt = "-"..Truncate(unit.healthmax - unit.health)
			end
		else
			HpAmt = Truncate(unit.health)
		end
	else HpAmt = ""
	end
	if TidyPlatesThreat.db.profile.text.max then
		if TidyPlatesThreat.db.profile.text.amount then
			if TidyPlatesThreat.db.profile.text.deficit and unit.health == unit.healthmax then
				HpMax = Truncate (unit.healthmax)
			else
				HpMax = " / "..Truncate(unit.healthmax)
			end
		else 
			HpMax = Truncate(unit.healthmax)
		end
	else 
		HpMax = ""
	end
	if TidyPlatesThreat.db.profile.text.hptext then
		if (unit.health / unit.healthmax) < 1 then
			return HpAmt..HpMax..HpPct
		else
			if TidyPlatesThreat.db.profile.text.full then
				return HpAmt..HpMax..HpPct
			else 
				return ""
			end
		end
	else 
		return ""
	end
end

function SetSpecialText2(unit)
	if TidyPlatesThreat.db.profile.text.cast then
		local spellname
		if unit.isCasting then 
			spellname = UnitCastingInfo("target") or UnitChannelInfo("target")
			return spellname
		else return ""
		end
	end
end

function SetSpecialArt(unit)
	local threatLevel 
	local style = SetStyle(unit)
	if TidyPlatesThreat.db.profile.threat.tanking then
		threatLevel = unit.threatSituation
	else
		if unit.threatSituation == "HIGH" then
			threatLevel = "LOW"
		elseif unit.threatSituation == "LOW" then
			threatLevel = "HIGH"
		elseif unit.threatSituation == "MEDIUM" then
			threatLevel = "MEDIUM"
		end
	end
	if style == "tank" or style == "dps" and InCombatLockdown() and unit.class == "UNKNOWN" then
		if unit.isMarked and TidyPlatesThreat.db.profile.threat.marked.art then
			return nil
		else
			return path..TidyPlatesThreat.db.profile.theme.."\\"..threatLevel
		end
	elseif unit.class and (unit.class ~= "UNKNOWN") then
		return classicon..unit.class
	else
		return nil
	end
end

local function SetScale(unit)
	local UnitClass = UnitType(unit)
	local style = SetStyle(unit)
	if style == "normal" then
		return TidyPlatesThreat.db.profile.nameplate.scale[UnitClass]
	elseif style == "tank" or style == "dps" then
		if unit.isMarked and TidyPlatesThreat.db.profile.threat.marked.scale then
			return TidyPlatesThreat.db.profile.nameplate.scale[UnitClass]
		else
			return TidyPlatesThreat.db.profile.threat[style].scale[unit.threatSituation]
		end
	else 
		return 1
	end
end

local function SetAlpha(unit)
	local UnitClass = UnitType(unit)
	local style = SetStyle(unit)
	if style == "normal" then
		return TidyPlatesThreat.db.profile.nameplate.alpha[UnitClass]
	elseif style == "tank" or style == "dps" then
		if unit.isMarked and TidyPlatesThreat.db.profile.threat.marked.alpha then
			return TidyPlatesThreat.db.profile.nameplate.alpha[UnitClass]
		else
			return TidyPlatesThreat.db.profile.threat[style].alpha[unit.threatSituation]
		end
	else 
		return 1
	end
end

		
TidyPlatesThemeList["Threat Plates"].SetStyle = SetStyle
TidyPlatesThemeList["Threat Plates"].SetScale = SetScale
TidyPlatesThemeList["Threat Plates"].SetAlpha = SetAlpha
TidyPlatesThemeList["Threat Plates"].SetSpecialText = SetSpecialText
TidyPlatesThemeList["Threat Plates"].SetSpecialText2 = SetSpecialText2
TidyPlatesThemeList["Threat Plates"].SetSpecialArt = SetSpecialArt

--[[Events]]--
local setSpec = CreateFrame("Frame")
local eventlist = {}
local specCache = {};
function specName(current)
	return "Protection"
--[[TalentFrame_UpdateSpecInfoCache(specCache, false, false, GetActiveTalentGroup(false, false));
	current = specCache[specCache.primaryTabIndex].name;

	return current]]--
end

function eventlist:PLAYER_ENTERING_WORLD()
	local message = "|cff89F559Welcome to Tidy Plates: Threat Plates!\nThis is your first time using Threat Plates and you are a |r|cff"..classColors[PlayerClass]..UnitClass("player").."|r|cff89F559.\n"
	local endmessage = "Additional options can be found by typing |r'/tptp'|cff89F559.|r"
	if not TidyPlatesThreat.db.profile.welcome then
		TidyPlatesThreat.db.profile.welcome = true
		if PlayerClass == "SHAMAN" 
			or PlayerClass == "MAGE" 
			or PlayerClass == "WARLOCK" 
			or PlayerClass == "HUNTER" 
			or PlayerClass == "ROGUE" 
			or PlayerClass == "PRIEST" 
				then
			TidyPlatesThreat.db.profile.threat.tanking = false
			TidyPlatesThreat.db.profile.spec.primary = false
			TidyPlatesThreat.db.profile.spec.secondary = false
			print(message.."You cannot tank.\nYour dual spec settings have been set to |r|cffff0000dps / healing|r |cff89F559roles automatically.|cff89f559\n"..endmessage)
		elseif PlayerClass == "WARRIOR" 
			or PlayerClass == "PALADIN" 
				then 
			print(message.."Your tanking spec cannot be determined.\nPlease make sure you set your dual specs in the Threat Plates options.\n"..endmessage)
			--[[if specName(current) == "Protection" then
				print(message.."You're currently in your tanking spec.\nYour current spec has been set to |r|cff00ff00tanking|r.|cff89f559\n"..endmessage)
				if GetActiveTalentGroup() == 1 then
					TidyPlatesThreat.db.profile.spec.primary = true
					TidyPlatesThreat.db.profile.spec.secondary = false
				elseif GetActiveTalentGroup() == 2 then
					TidyPlatesThreat.db.profile.spec.primary = false
					TidyPlatesThreat.db.profile.spec.secondary = true
				end
			else
				print(message.."Your tanking spec cannot be determined.\nPlease make sure you set your dual specs in the Threat Plates options.\n"..endmessage)
			end]]--
		elseif PlayerClass == "DRUID" then
			print(message.."Your tanking spec cannot be determined.\nPlease make sure you set your dual specs in the Threat Plates options.\n"..endmessage)
		elseif PlayerClass == "DEATHKNIGHT" then
			print(message.."Your tanking spec cannot be determined.\nPlease make sure you set your dual specs in the Threat Plates options.\n"..endmessage)
		else
			print(message..endmessage)
		end
		-- Theme isn't active warning.
		if TidyPlatesOptions.theme ~= "Threat Plates" then
			print("-->>|cffff0000You are currently using the |r'"..TidyPlatesOptions.theme.."'|cffff0000 theme |r<<--\n-->>|cffff0000Activate Threat Plates from the Tidy Plates options!|r<<--")
		end
		--TidyPlates:UseAutoHide(TidyPlatesThreat.db.profile.nameplate.autohide)
	else
		--TidyPlates:UseAutoHide(TidyPlatesThreat.db.profile.nameplate.autohide)
		TidyPlatesThreat.db.profile.threat.tanking = currentRoleBool(GetActiveTalentGroup())
	end	
end

function eventlist:ACTIVE_TALENT_GROUP_CHANGED()
	TidyPlatesThreat.db.profile.threat.tanking = currentRoleBool(GetActiveTalentGroup())
	print("|cff89F559Threat Plates|r: Player spec change detected, you are now in your |cff89F559"..dualSpec(current).."|r spec and are now in your "..roleText(current).." role.")
	TidyPlates:ForceUpdate()
end

setSpec:SetScript("OnEvent", function(self, event) eventlist[event]() end)
setSpec:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
setSpec:RegisterEvent("PLAYER_ENTERING_WORLD")

--[[
local setAutoHide = CreateFrame("Frame")
local eventlist2 = {}

function eventlist2:PLAYER_REGEN_ENABLED()
	if TidyPlatesThreat.db.profile.nameplate.autohide then
		SetCVar("nameplateShowEnemies", 0)
	end
end

function eventlist2:PLAYER_REGEN_DISABLED()
	if TidyPlatesThreat.db.profile.nameplate.autohide then
		SetCVar("nameplateShowEnemies", 1)
	end
end

setAutoHide:SetScript("OnEvent", function(self, event) eventlist2[event]() end)
setSpec:RegisterEvent("PLAYER_REGEN_ENABLED")
setSpec:RegisterEvent("PLAYER_REGEN_DISABLED")
]]--
--[[Auto Settings]]--
SetCVar("threatWarning", 3)
SetCVar("nameplateShowEnemies", 1)
SetCVar("ShowClassColorInNameplate", 1)
